//-----------------------------------------------------------------------------
// Torque Game Engine 
// Copyright (C) GarageGames.com, Inc.
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Server Admin Commands
//-----------------------------------------------------------------------------

function SAD(%password)
{
   if (%password !$= "")
      commandToServer('SAD', %password);
}

function SADSetPassword(%password)
{
   commandToServer('SADSetPassword', %password);
}


//----------------------------------------------------------------------------
// Misc server commands
//----------------------------------------------------------------------------

function clientCmdSyncClock(%time)
{
   // Time update from the server, this is only sent at the start of a mission
   // or when a client joins a game in progress.
}

//--------------------------------------------------------------------------
// COGMAC
//--------------------------------------------------------------------------

function clientCmdEnableMouseClicks()
{
   // Already toggled.
   if( !crosshair.isVisible() ) return;

   // Toggle cursor in 1st person.
   if ($firstPerson)
   {
      %resolution = PlayGui.getExtent();
      %resX = (getWord(%resolution, 0) / 2);
      %resY = (getWord(%resolution, 1) / 2);
      %mousePos = %resX SPC %resY;

      Canvas.setCursorPos( %mousePos );
      Canvas.cursorOn();
      crosshair.setVisible(false);
   }
}

function clientCmdShowInteractionGui(%mousePos)
{
   // No specific mouse position has been set.
   // Set the mouse position to the center of the screen.
   if( %mousePos == 0 )
   {
      %resolution = PlayGui.getExtent();
      %resX = (getWord(%resolution, 0) / 2);
      %resY = (getWord(%resolution, 1) / 2);
      %mousePos = %resX SPC %resY;
   }

   %resolution = PlayGui.getExtent();
   %resX = getWord(%resolution, 0);
   %resY = getWord(%resolution, 1);

   %extents = myWindow.getExtent();
   %extX = getWord(%extents, 0);
   %extY = getWord(%extents, 1);

   %posX = getWord(%mousePos, 0);
   %posY = getWord(%mousePos, 1);

   if( %posX + %extX >= %resX ) %posX = %resX - %extX;
   if( %posY + %extY >= %resY ) %posY = %resY - %extY;

   myWindow.setPosition( %posX, %posY );
   myWindow.setVisible(true);

   dlgLookAt.setVisible(false);
   dlgCreateBill.setVisible(false);
   dlgPayBill.setVisible(false);
   dlgMenu.setVisible(false);
   dlgFurniture.setVisible(false);
   dlgDummy.setVisible(false);
}

function clientCmdCleanupPopup()
{
   myWindow.setVisible(false);
   dlgLookAt.setVisible(false);
   dlgCreateBill.setVisible(false);
   dlgPayBill.setVisible(false);
   dlgMenu.setVisible(false);
   dlgFurniture.setVisible(false);
   dlgDummy.setVisible(false);
   dlgEarnMoney.setVisible(false);
   dlgNotEnoughMoney.setVisible(false);
///   setSelectedObject( 0 );

   if( dlgTutorial.tutor.isComplete )
   {
      dlgTutorial.setVisible(false);
   }

   // Toggle cursor in 1st person.
   if ($firstPerson)
   {
      Canvas.cursorOff();
      crosshair.setVisible(true);
   }
}

function clientCmdClosePaymentDlg()
{
   dlgPayBill.setVisible(false);
}

function clientCmdShowLookAtGui(%bitmap)
{
   // Toggle cursor in 1st person.
   if ($firstPerson)
   {
      Canvas.cursorOn();
      crosshair.setVisible(false);
   }

   bmpLookAt.setBitmap(%bitmap);
   dlgLookAt.setVisible(true);
   myWindow.setVisible(false);
}

function clientCmdShowFurnitureGui()
{
   // Toggle cursor in 1st person.
   if ($firstPerson)
   {
      Canvas.cursorOn();
      crosshair.setVisible(false);
   }

   dlgFurniture.setVisible(true);
   myWindow.setVisible(false);
}

function clientCmdShowDummyGui(%note)
{
   // Toggle cursor in 1st person.
   if ($firstPerson)
   {
      Canvas.cursorOn();
      crosshair.setVisible(false);
   }

   bmpDummy.setBitmap(%note);
   dlgDummy.setVisible(true);
   myWindow.setVisible(false);
}

function clientCmdShowMenuGui()
{
   // Toggle cursor in 1st person.
   if ($firstPerson)
   {
      Canvas.cursorOn();
      crosshair.setVisible(false);
   }

   dlgMenu.setVisible(true);
   myWindow.setVisible(false);
}

function clientCmdShowRegisterGui()
{
   // Toggle cursor in 1st person.
   if ($firstPerson)
   {
      Canvas.cursorOn();
      crosshair.setVisible(false);
   }

   InitializeCreateBillDlg();
   dlgCreateBill.setVisible(true);
   myWindow.setVisible(false);
}

function clientCmdShowBillGui( %bill,
                               %lstItems0, %lstItems1, %lstItems2, %lstItems3, %lstItems4,
                               %lstItems5, %lstItems6, %lstItems7, %lstItems8, %lstItems9,
                               %subtotal, %tax, %tip, %total, %paid )
{
   // Toggle cursor in 1st person.
   if ($firstPerson)
   {
      Canvas.cursorOn();
      crosshair.setVisible(false);
   }

   InitializePayBillDlg( %bill, 
                         %lstItems0, %lstItems1, %lstItems2, %lstItems3, %lstItems4,
                         %lstItems5, %lstItems6, %lstItems7, %lstItems8, %lstItems9,
                         %subtotal, %tax, %tip, %total, %paid );

   dlgPayBill.setVisible(true);
   myWindow.setVisible(false);
}

function clientCmdShowEarnMoneyGui( %payer, %payee, %subtotal, %tip, %totalEarned, %pos )
{
   // Toggle cursor in 1st person.
   if ($firstPerson)
   {
      Canvas.cursorOn();
      crosshair.setVisible(false);
   }

   InitializeEarnMoneyDlg( %payer, %payee, %subtotal, %tip, %totalEarned, %pos );

   dlgEarnMoney.setVisible(true);
   myWindow.setVisible(false);
}

function clientCmdShowIntroWaitress()
{
   dlgTutorial.setVisible(false);
   schedule( 1000, 0, ShowIntroWaitress );
}

function ShowIntroWaitress()
{
   Canvas.pushDialog( IntroWaitressDlg );
}

function clientCmdShowIntroCustomer()
{
   dlgTutorial.setVisible(false);
   schedule( 1000, 0, ShowIntroCustomer );
}

function ShowIntroCustomer()
{
   Canvas.pushDialog( IntroCustomerDlg );
}

function clientCmdSetCrosshair( %type )
{
   if( %type $= "down" )
   {
      crosshair.setBitmap( "restaurant/data/interface/CUR_putdown.png" );
      crosshair.setExtent( 48, 48 );
   }
   else if( %type $= "give" )
   {
      crosshair.setBitmap( "restaurant/data/interface/CUR_give.png" );
      crosshair.setExtent( 48, 48 );
   }
   else 
   {
      crosshair.setBitmap( "common/ui/CUR_3darrow.png" );
      crosshair.setExtent( 16, 32 );
   }
}

function clientCmdPlayerExit( %other )
{
   mousemod( 0 );
   ObjectiveComplete( %other );
}

// Useful functions for debugging network connections.
function GetServerName()
{
   CommandToServer( 'GetServerName' );
}

function clientCmdShowServerName(%name)
{
   echo("SERVER NAME:" SPC %name);
}

function clientCmdDisplayCurrentBalance(%bal)
{
   DisplayCurrentBalance(%bal);
}

function DisplayCurrentBalance(%bal)
{
   // Format the message.
   txtBalance.setText( "[you have" SPC FormatCashOutput( %bal ) @ "]" );

   // Keep text in same position relative to right side.
   %pos = txtBalance.getPosition();
   %resolution = PlayGui.getExtent();
   %resX = getWord(%resolution, 0);
   %width = txtBalance.getTextWidth() + 5;
   txtBalance.setPosition( %resX - %width, getWord(%pos, 1) );

   // Resize the background bmp to cover text.
   %ext = bmpBalance.getExtent();
   %pos = bmpBalance.getPosition();
   bmpBalance.setExtent( %width + 5, getWord(%ext, 1) );
   bmpBalance.setPosition( %resX - %width - 5, getWord(%pos, 1) );
}

function CleanupClient()
{
   clientCmdCleanupPopup();

   txtChat.setVisible(false);
   bmpChatText.setVisible(false);
   txtChatSmall.setVisible(false);
   bmpChatOtherText.setVisible(false);
   txtChatOther.setVisible(false);
   txtChatOtherSmall.setVisible(false);
   txtNarration.setVisible(false);
   txtNoListenerWarning.setVisible(false);

   txtChat.setText("");
   txtChatSmall.setText("");
   txtChatOther.setText("");
   txtChatOtherSmall.setText("");

   dlgSurvey.setVisible(false);
   txtAdjective1.setVisible(false);
   txtAdjective2.setVisible(false);
   txtAdjective3.setVisible(false);
   txtWhereFrom.setVisible(false);
   txtOccupation.setVisible(false);
   txtBreakfast.setVisible(false);
   txtProblems.setVisible(false);
}

function WaitToStartGame()
{
   btnLoadingCancel.setVisible(false);
   LoadingProgress.setVisible(false);

   btnLoadingOk.setVisible(true);
}

function clientCmdClientDropped( %name )
{
   // Client already submitted survey.
   // Everything is Ok.
   if( lstProfile.receivedReport ) return;

   // Client quit during a game.
   if( $GameplayEnabled ) 
   {
      MessageBoxOK("OTHER PLAYER QUIT", "THE OTHER PLAYER HAS EXITED THE GAME PREMATURELY. THE GAME WILL NOW END. SORRY!", "disconnect();" );
      return;
   }

   // Client quit before submitting survey.
   // Let user know that none is coming.
   lstProfile.otherQuit = true;
   lstProfile.clear();
   lstProfile.addRow( 0, "The other player quit without submiting the survey. Sorry!" );
   btnProfileOk.setVisible(true);
}

function WhoElse()
{
   CommandToServer( 'WhoElse' );
}

function clientCmdRespondWhoElse( %email, %name )
{
   echo( "Other Player is" SPC %email SPC %name );
}

function clientCmdConfirmDeposit(%pos)
{
   // Play a ding sound.
   %soundDing = "~/data/sound/cogmac/ding.wav";
   PlaySound( %soundDing, %pos );

   %mousePos = crosshair.getPosition();
   Canvas.setCursorPos( %mousePos );
   crosshair.setVisible(false);
   Canvas.cursorOn();

   MessageBoxYesNo( "CONFIRM DEPOSIT", "ARE YOU SURE YOU WANT TO DEPOSIT A CHECK THAT YOU PAID YOURSELF?\n\nCLICK 'YES' TO DEPOSIT THE CHECK AND EARN 50% OF THE TOTAL PLUS TIP.\nOTHERWISE CLICK 'NO'", "CommandToServer('CompleteDeposit');", "clientCmdCleanupPopup();" );
}

//--------------------------------------------------------------------------
// COGMAC
//--------------------------------------------------------------------------




























