//-------------------------------------------------------------------------------
// DBHeavy
//-------------------------------------------------------------------------------

datablock StaticShapeData(DBHeavy : DBObject)
{
   // The category variable determines where the item
   // shows up in the mission editor's creator tree.
   // Path is relative to where the script is executed from.
   category = "Restaurant";
   shapeFile = "~/data/shapes/restaurant/stove/stove.dts";
   bitmap = "";
   soundTouch = "~/data/sound/cogmac/grill.wav";
};

function DBHeavy::onAdd(%this, %obj) { DBObject::OnAdd(%this, %obj); }
function DBHeavy::OnSit( %this, %client, %user, %obj ) { DBObject::OnSit( %this, %client, %user, %obj ); }
function DBHeavy::OnLookAt( %this, %client, %obj ) { DBObject::OnLookAt( %this, %client, %obj ); }
function DBHeavy::OnEat( %this, %client, %obj ) { DBObject::OnEat( %this, %client, %obj ); }
function DBHeavy::OnTouch( %this, %client, %user, %obj ) { DBObject::OnTouch( %this, %client, %user, %obj ); }
function DBHeavy::OnGive( %this, %client, %user, %obj, %target, %pos ) { DBObject::OnGive( %this, %client, %user, %obj, %target, %pos ); }

function DBHeavy::OnPickup( %this, %client, %user, %obj )
{
   CommandToClient( %client, 'CleanupPopup' );

   COGLOG_STATECHANGE( %client.player, "ATPOS", COGLOG_POS(%client.player.getPosition()) );
   COGLOG_ACTION( %client.player, "PICKUP", %obj );

   SetNarration( %client, "[" @ %client.player.getName() SPC "tried to pick up the" SPC %obj.getDataBlock().noun @ "]" );

   // Play a pickup sound.
   %soundPickup = %user.getDataBlock().soundPickup;
   PlaySound( %soundPickup, %user.getPosition() );
}

//-------------------------------------------------------------------------------

datablock StaticShapeData(DBStove : DBHeavy)
{
   className = "DBHeavy";
   shapeFile = "~/data/shapes/restaurant/stove/stove.dts";
   bitmap = "restaurant/data/shapes/restaurant/stove/stove.bmp";
   soundTouch = "~/data/sound/cogmac/grill.wav";
   noun = "stove";
};

datablock StaticShapeData(DBBar : DBHeavy)
{
   className = "DBHeavy";
   shapeFile = "~/data/shapes/restaurant/juice_bar/bar.dts";
   bitmap = "restaurant/data/shapes/restaurant/juice_bar/bar.bmp";
   soundTouch = "~/data/sound/cogmac/knock3.wav";
   cleansDirty = true;
   noun = "bar";
};

datablock StaticShapeData(DBFridge : DBHeavy)
{
   className = "DBHeavy";
   shapeFile = "~/data/shapes/restaurant/refridgerator/fridge.dts";
   bitmap = "restaurant/data/shapes/restaurant/refridgerator/fridge.bmp";
   soundTouch = "~/data/sound/cogmac/fridge_door.wav";
   noun = "refrigerator";
};

datablock StaticShapeData(DBTrashCompactor : DBHeavy)
{
   className = "DBHeavy";
   shapeFile = "~/data/shapes/restaurant/trash_compactor/trash_compactor.dts";
   bitmap = "restaurant/data/shapes/restaurant/trash_compactor/trash_compactor.bmp";
   soundTouch = "~/data/sound/cogmac/machine3.wav";
   cleansDirty = true;
   noun = "trash compactor";
};

datablock StaticShapeData(DBTable : DBHeavy)
{
   className = "DBHeavy";
   shapeFile = "~/data/shapes/restaurant/table_fancy/table_fancy.dts";
   bitmap = "restaurant/data/shapes/restaurant/table_fancy/table_fancy.bmp";
   soundTouch = "~/data/sound/cogmac/knock3.wav";
   noun = "table";
};

datablock StaticShapeData(DBCounter : DBHeavy)
{
   className = "DBHeavy";
   shapeFile = "~/data/shapes/restaurant/counter_fancy/counter_fancy.dts";
   bitmap = "restaurant/data/shapes/restaurant/counter_fancy/counter_fancy.bmp";
   soundTouch = "~/data/sound/cogmac/knock3.wav";
   cleansDirty = true;
   noun = "counter";
};

datablock StaticShapeData(DBCounterOpen : DBHeavy)
{
   className = "DBHeavy";
   shapeFile = "~/data/shapes/restaurant/counter_fancy/counter_fancy_open.dts";
   bitmap = "restaurant/data/shapes/restaurant/sink_fancy/sink_fancy.bmp";
   soundTouch = "~/data/sound/cogmac/faucett.wav";
   cleansDirty = true;
   noun = "sink";
};

datablock StaticShapeData(DBCounterCorner : DBHeavy)
{
   className = "DBHeavy";
   shapeFile = "~/data/shapes/restaurant/counter_fancy/counter_fancy_east.dts";
   bitmap = "restaurant/data/shapes/restaurant/counter_fancy/counter_fancy.bmp";
   soundTouch = "~/data/sound/cogmac/knock3.wav";
   cleansDirty = true;
   noun = "counter";
};

datablock StaticShapeData(DBDishWasher : DBHeavy)
{
   className = "DBHeavy";
   shapeFile = "~/data/shapes/restaurant/dish_washer/dish_washer.dts";
   bitmap = "restaurant/data/shapes/restaurant/dish_washer/dish_washer.bmp";
   soundTouch = "~/data/sound/cogmac/dish_washer.wav";
   cleansDirty = true;
   noun = "dish washer";
};

datablock StaticShapeData(DBPodium : DBHeavy)
{
   className = "DBHeavy";
   shapeFile = "~/data/shapes/restaurant/podium/podium.dts";
   bitmap = "restaurant/data/shapes/restaurant/podium/podium.bmp";
   soundTouch = "~/data/sound/cogmac/knock3.wav";
   noun = "podium";
};
















